/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * 'License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        // Device Ready.
        app.receivedEvent('deviceready');

        // Callbacks.                 
        window.plugins.inAppPurchaseManager.onPurchased = function(transactionIdentifier, productId, transactionReceipt) {
            console.log('transactionIdentifier: ' + transactionIdentifier + ' productId: ' + productId + ' transactionReceipt: ' + transactionReceipt);
        }
        
         
        window.plugins.inAppPurchaseManager.onRestored = function(originalTransactionIdentifier, productId, originalTransactionReceipt) {
            console.log('originalTransactionIdentifier: ' + originalTransactionIdentifier + ' productId: ' + productId + ' originalTransactionReceipt: ' + originalTransactionReceipt);
        }
         
        window.plugins.inAppPurchaseManager.onFailed = function(errorCode, errorText) {
            console.log('errorCode:' + errorCode + ' errorText: ' + errorText);                         
        }

        // Product com.firetrust.mailwashermobile.1year                      
        window.plugins.inAppPurchaseManager.requestProductData('com.firetrust.mailwashermobile.1year', function(productId, title, description, price) {
            console.log('productId: ' + productId + ' title: ' + title + ' description: ' + description + ' price: ' + price);
            console.log('-- Making Purchase --');
            window.plugins.inAppPurchaseManager.makePurchase(productId, 1);
        }, function(id) {
            console.log('Invalid product id: ' + id);
        }
    );

    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        var parentElement = document.getElementById(id);
        var listeningElement = parentElement.querySelector('.listening');
        var receivedElement = parentElement.querySelector('.received');

        listeningElement.setAttribute('style', 'display:none;');
        receivedElement.setAttribute('style', 'display:block;');

        console.log('Received Event: ' + id);
    }
};
